<?php
/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    CWS_Flickr_Gallery_Pro
 * @subpackage CWS_Flickr_Gallery_Pro/includes
 * @author     Ian Kennerley <info@cheshirewebsolutions.com>
 */
class CWS_Flickr_Gallery_Pro_Activator {

	/**
	 * Short Description.
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function activate() {

		$cws_fgp_options = array(
					'num_image_results' => 4,
					'thumb_size' => 'square_150',
					'privacy_filter' => "1",
					'show_album_title' => 1,
					'show_album_details' => 0,
					'show_image_title' => 1,
					'results_page' => '',
					'theme' => '',
					'lightbox_image_size' => 'small_320',
					'enable_cache' => '',
					'row_height' => '250',
				);
        						
		update_option( 'cws_fgp_options', $cws_fgp_options );    
	}
}